#lang plai




(require "DefinicionesMTR.rkt")




#|Procedimiento que regresa los valores respectivos a cada elemento de una lista|#    
(define identidadV
  (lambda (lista ds)   
    (if (= (length lista) 0)
        null
        ( append  (identidadV (remove (last lista) lista) ds)(list (eval(last lista) ds))))))




#|Procedimiento que implementa el algoritmo de evaluación|#
(define (eval expr ds) 
  (type-case MinTyRacket expr
    [CONST (elem ls) (cons (eval elem ds) (eval ls ds))]
    [ISEMPTY? (ls) 
              (cond [(and (listV? (eval ls ds)) 
                          (equal? empty (listV-ls (eval ls ds)))) true]
                    [else (empty? (eval ls ds))])]
    [ERROR () (ERROR)]
    (FST(LS)
        (car (eval  LS  ds)))
    [LIST (ls)  (identidadV ls ds) ]
    (RST (LS)
         (cdr (eval  LS  ds)))
    [true_ () (booleanV true_)]
    [NULL (tipo) (listV empty)]
    [false_ () (booleanV false_)]
    [bool (n)
          (if  (equal? n #t)  (booleanV true)  (booleanV false)  )]
    [num (n)
         (integerV n)]
    [doub (n) 
          (doubleV n)]
        [flot (n)
          (floatV n)]
    [OP (op IZQ DER)
           ((cadr (assoc op opbinarias))
            (eval IZQ ds)
            (eval DER ds))]
    [VAR (v) (lookup v ds) ]
    [IF (cond true else)
         (if (booleanV? (eval cond ds))
             (if (equal? (booleanV-n (eval cond ds)) #t)
                 (eval true ds)
                 (eval else ds))
             (error "condicional no es de tipo boleano:  " (eval cond ds)))]
    [LAMBDA (paramlist types  body)
          (closureV paramlist body ds)]
    [FIX (varlig named cuerpolig)
      (eval cuerpolig          
              (ciclico varlig named ds))]
    (APP (f_expr arglist)
         
         (if (closureV? (eval f_expr ds))
             (eval (closureV-body (eval f_expr ds))
                     (args_env (closureV-params (eval f_expr ds))
                               arglist
                               (closureV-env (eval f_expr ds))
                               ds))
             (error "aplicacion requiere ser aplicada en una funcion: " (eval f_expr ds))
             )))) 




#|Procedimiento que dada una lista de argumentos, una lista de valores, y ambientes,
 comprueba que cada argumento tenga un valor asociado, en caso que así sea 
extiende el ambiente recibido con los nuevos argumentos y valores recibidos|#
(define (args_env params argu_list foo_env arg_env)
  (cond
    ((and (empty? params)
          (empty? argu_list))
     foo_env)
    ((or (and (empty? params)
              (not (empty? argu_list)))
         (and (not (empty? params))
              (empty? argu_list)))
     (error "lista de parametros y lista de argumentos no son de la misma longitud"))
    (else
     (args_env (cdr params)
               (cdr argu_list)
               (anEnv (car params)
                      (eval (car argu_list) arg_env)
                      foo_env)
               arg_env))))




#|Procedimiento que busca el identificador en un ambiente de valores 
y regresa el valor ligado en caso de que exista|#
(define (lookup nombre ds)
  (type-case Env ds
    (mtEnv () (error "no existe ligadura para el identificador: " nombre))
    (anEnv (nombre_lig valor_lig env)
           (if (equal? nombre_lig nombre)
               valor_lig
               (lookup nombre env)))
    [aRecSub (nombrelig valorlig soc)
             (if (symbol=? nombrelig nombre)
                 
                 (unbox valorlig)
                 (lookup nombre soc))]))




#|Implementación de los ambientes cíclicos procedurales|#
(define (ciclico liga expr env)
  (local([define valor (box (integerV 2830))]
         [define nuevo_env (aRecSub liga valor env)]
         [define expr_valor (eval expr nuevo_env)])
    (begin
      (set-box! valor expr_valor)
      nuevo_env)))

